﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace RuEn
{
    /// <summary>
    /// Attribute class for Collection Duplicate Rules. Check for duplication in an collection
    /// </summary>
    [AttributeUsage(AttributeTargets.Property, Inherited=false, AllowMultiple=true)]
    public class StringCollectionRule : CollectionRuleBase
    {
        private string _errorMessage = "Duplicate Items found";

        /// <summary>
        /// Default Constructoe
        /// </summary>
        public StringCollectionRule()
        {
        }

        /// <summary>
        /// Overloaded Constructor
        /// </summary>
        /// <param name="ErrorMessage">Custom Error message from the User</param>
        public StringCollectionRule(string ErrorMessage)
        {
            _errorMessage = ErrorMessage;
        }

        /// <summary>
        /// Public property to assign custom error message
        /// </summary>
        public string ErrorMessage
        {
            get { return _errorMessage; }
            set { _errorMessage = value; }
        }

        public bool Validate(IEnumerable<string> value, string ErrorMessage)
        {
            bool state = true;
            List<string> tempCol = new List<string>();
            if (value != null)
            {
                foreach (string s in value)
                {
                    if (tempCol.Contains(s))
                    {
                        state = false;
                        break;
                    }
                    else
                    {
                        tempCol.Add(s);
                    }
                }
            }
            return state;
        }
    }
}
